#include "vma.h"
#include "param.h"
#include "memlayout.h"
#include "include/spinlock.h"
#include "proc.h"
#include "defs.h"

struct vm_area_struct *find_vma(struct mm_struct *mm, uint64 addr){
    struct vm_area_struct *ptr; 
    if(mm == 0 || (ptr = mm->mmap) == 0){
        return 0;
    }
    while(ptr->vm_next != 0){
        if(ptr->vm_start >= addr && ptr->vm_end < addr){
            return ptr;
        }
        ptr = ptr->vm_next;
    }
    return 0;
}


uint64 do_mmap(struct mm_struct *mm, uint64 addr, uint64 len, uint64 vm_pgoff, uint64 vm_filesz, uint64 flags){
    if(len == 0)
        return -1;
            
    len = PGROUNDUP(len);


}